var http = require('http')
  , fs = require('fs')
  , path = require('path')
  , async = require('async');

var application = function (routes) {

  var self = function (req, res, next) {
    self.handle(req, res, next);
  };

  self.boot = function (paths, callback) {
    var pwd = process.env.PWD;

    fs.readdir(path.join(pwd, paths.controllers), function (err, data) {
      if (err) throw err;

      data.forEach(function (file) {
        var controller = path.basename(file, '.js');
        self.controllers[controller] = require(path.join(pwd, paths.controllers, file));
      });

      callback();
    });
  };

  self.handle = function (req, res, next) {
    res.end('domo.');
  };

  self.listen = function () {
    var server = http.createServer(this);
    return server.listen.apply(server, arguments);
  };

  self.routes = routes;
  self.controllers = {};

  return self;
};

exports = module.exports = application;